Whamcloud - gitweb
b=23408 disable failure temporarily while we collect performance stats
[fs/lustre-release.git] / lustre / tests / replay-single.sh
1 #!/bin/bash
2
3 set -e
4 #set -v
5
6 #
7 # This test needs to be run on the client
8 #
9 SAVE_PWD=$PWD
10 LUSTRE=${LUSTRE:-$(cd $(dirname $0)/..; echo $PWD)}
11 SETUP=${SETUP:-}
12 CLEANUP=${CLEANUP:-}
13 . $LUSTRE/tests/test-framework.sh
14 init_test_env $@
15 . ${CONFIG:=$LUSTRE/tests/cfg/$NAME.sh}
16 init_logging
17 CHECK_GRANT=${CHECK_GRANT:-"yes"}
18 GRANT_CHECK_LIST=${GRANT_CHECK_LIST:-""}
19
20 require_dsh_mds || exit 0
21
22 # Skip these tests
23 # bug number:  17466 18857
24 ALWAYS_EXCEPT="61d   33a 33b     $REPLAY_SINGLE_EXCEPT"
25
26 if [ "$FAILURE_MODE" = "HARD" ] && mixed_ost_devs; then
27     CONFIG_EXCEPTIONS="0b 42 47 61a 61c"
28     echo -n "Several ost services on one ost node are used with FAILURE_MODE=$FAILURE_MODE. "
29     echo "Except the tests: $CONFIG_EXCEPTIONS"
30     ALWAYS_EXCEPT="$ALWAYS_EXCEPT $CONFIG_EXCEPTIONS"
31 fi
32
33 #                                                  63 min  7 min  AT AT AT AT"
34 [ "$SLOW" = "no" ] && EXCEPT_SLOW="1 2 3 4 6 12 16 44a      44b    65 66 67 68"
35
36 build_test_filter
37
38 check_and_setup_lustre
39
40 mkdir -p $DIR
41
42 assert_DIR
43 rm -rf $DIR/[df][0-9]*
44
45 test_0a() {     # was test_0
46     sleep 10
47     mkdir $DIR/$tfile
48     replay_barrier $SINGLEMDS
49     fail $SINGLEMDS
50     rmdir $DIR/$tfile
51 }
52 run_test 0a "empty replay"
53
54 test_0b() {
55     remote_ost_nodsh && skip "remote OST with nodsh" && return 0
56
57     # this test attempts to trigger a race in the precreation code,
58     # and must run before any other objects are created on the filesystem
59     fail ost1
60     createmany -o $DIR/$tfile 20 || return 1
61     unlinkmany $DIR/$tfile 20 || return 2
62 }
63 run_test 0b "ensure object created after recover exists. (3284)"
64
65 seq_set_width()
66 {
67     local mds=$1
68     local width=$2
69     lctl set_param -n seq.cli-srv-$mds-mdc-*.width=$width
70 }
71
72 seq_get_width()
73 {
74     local mds=$1
75     lctl get_param -n seq.cli-srv-$mds-mdc-*.width
76 }
77
78 # This test should pass for single-mds and multi-mds configs.
79 # But for different configurations it tests different things.
80 #
81 # single-mds
82 # ----------
83 # (1) fld_create replay should happen;
84 #
85 # (2) fld_create replay should not return -EEXISTS, if it does
86 # this means sequence manager recovery code is buggy and allocated
87 # same sequence two times after recovery.
88 #
89 # multi-mds
90 # ---------
91 # (1) fld_create replay may not happen, because its home MDS is
92 # MDS2 which is not involved to revovery;
93 #
94 # (2) as fld_create does not happen on MDS1, it does not make any
95 # problem.
96 test_0c() {
97     local label=`mdsdevlabel 1`
98     [ -z "$label" ] && echo "No label for mds1" && return 1
99
100     replay_barrier $SINGLEMDS
101     local sw=`seq_get_width $label`
102
103     # make seq manager switch to next sequence each
104     # time as new fid is needed.
105     seq_set_width $label 1
106
107     # make sure that fld has created at least one new
108     # entry on server
109     touch $DIR/$tfile || return 2
110     seq_set_width $label $sw
111
112     # fail $SINGLEMDS and start recovery, replay RPCs, etc.
113     fail $SINGLEMDS
114
115     # wait for recovery finish
116     sleep 10
117     df $MOUNT
118
119     # flush fld cache and dentry cache to make it lookup
120     # created entry instead of revalidating existent one
121     umount $MOUNT
122     zconf_mount `hostname` $MOUNT
123
124     # issue lookup which should call fld lookup which
125     # should fail if client did not replay fld create
126     # correctly and server has no fld entry
127     touch $DIR/$tfile || return 3
128     rm $DIR/$tfile || return 4
129 }
130 start_full_debug_logging
131 run_test 0c "fld create"
132 stop_full_debug_logging
133
134 test_1() {
135     replay_barrier $SINGLEMDS
136     mcreate $DIR/$tfile
137     fail $SINGLEMDS
138     $CHECKSTAT -t file $DIR/$tfile || return 1
139     rm $DIR/$tfile
140 }
141 run_test 1 "simple create"
142
143 test_2a() {
144     replay_barrier $SINGLEMDS
145     touch $DIR/$tfile
146     fail $SINGLEMDS
147     $CHECKSTAT -t file $DIR/$tfile || return 1
148     rm $DIR/$tfile
149 }
150 run_test 2a "touch"
151
152 test_2b() {
153     mcreate $DIR/$tfile
154     replay_barrier $SINGLEMDS
155     touch $DIR/$tfile
156     fail $SINGLEMDS
157     $CHECKSTAT -t file $DIR/$tfile || return 1
158     rm $DIR/$tfile
159 }
160 run_test 2b "touch"
161
162 test_3a() {
163     local file=$DIR/$tfile
164     replay_barrier $SINGLEMDS
165     mcreate $file
166     openfile -f O_DIRECTORY $file
167     fail $SINGLEMDS
168     $CHECKSTAT -t file $file || return 2
169     rm $file
170 }
171 run_test 3a "replay failed open(O_DIRECTORY)"
172
173 test_3b() {
174     replay_barrier $SINGLEMDS
175 #define OBD_FAIL_MDS_OPEN_PACK | OBD_FAIL_ONCE
176     do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000114"
177     touch $DIR/$tfile
178     do_facet $SINGLEMDS "lctl set_param fail_loc=0"
179     fail $SINGLEMDS
180     $CHECKSTAT -t file $DIR/$tfile && return 2
181     return 0
182 }
183 run_test 3b "replay failed open -ENOMEM"
184
185 test_3c() {
186     replay_barrier $SINGLEMDS
187 #define OBD_FAIL_MDS_ALLOC_OBDO | OBD_FAIL_ONCE
188     do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000128"
189     touch $DIR/$tfile
190     do_facet $SINGLEMDS "lctl set_param fail_loc=0"
191     fail $SINGLEMDS
192
193     $CHECKSTAT -t file $DIR/$tfile && return 2
194     return 0
195 }
196 run_test 3c "replay failed open -ENOMEM"
197
198 test_4a() {     # was test_4
199     replay_barrier $SINGLEMDS
200     for i in `seq 10`; do
201         echo "tag-$i" > $DIR/$tfile-$i
202     done
203     fail $SINGLEMDS
204     for i in `seq 10`; do
205       grep -q "tag-$i" $DIR/$tfile-$i || error "$tfile-$i"
206     done
207 }
208 run_test 4a "|x| 10 open(O_CREAT)s"
209
210 test_4b() {
211     replay_barrier $SINGLEMDS
212     rm -rf $DIR/$tfile-*
213     fail $SINGLEMDS
214     $CHECKSTAT -t file $DIR/$tfile-* && return 1 || true
215 }
216 run_test 4b "|x| rm 10 files"
217
218 # The idea is to get past the first block of precreated files on both
219 # osts, and then replay.
220 test_5() {
221     replay_barrier $SINGLEMDS
222     for i in `seq 220`; do
223         echo "tag-$i" > $DIR/$tfile-$i
224     done
225     fail $SINGLEMDS
226     for i in `seq 220`; do
227       grep -q "tag-$i" $DIR/$tfile-$i || error "$tfile-$i"
228     done
229     rm -rf $DIR/$tfile-*
230     sleep 3
231     # waiting for commitment of removal
232 }
233 run_test 5 "|x| 220 open(O_CREAT)"
234
235
236 test_6a() {     # was test_6
237     mkdir -p $DIR/$tdir
238     replay_barrier $SINGLEMDS
239     mcreate $DIR/$tdir/$tfile
240     fail $SINGLEMDS
241     $CHECKSTAT -t dir $DIR/$tdir || return 1
242     $CHECKSTAT -t file $DIR/$tdir/$tfile || return 2
243     sleep 2
244     # waiting for log process thread
245 }
246 run_test 6a "mkdir + contained create"
247
248 test_6b() {
249     mkdir -p $DIR/$tdir
250     replay_barrier $SINGLEMDS
251     rm -rf $DIR/$tdir
252     fail $SINGLEMDS
253     $CHECKSTAT -t dir $DIR/$tdir && return 1 || true
254 }
255 run_test 6b "|X| rmdir"
256
257 test_7() {
258     mkdir -p $DIR/$tdir
259     replay_barrier $SINGLEMDS
260     mcreate $DIR/$tdir/$tfile
261     fail $SINGLEMDS
262     $CHECKSTAT -t dir $DIR/$tdir || return 1
263     $CHECKSTAT -t file $DIR/$tdir/$tfile || return 2
264     rm -fr $DIR/$tdir
265 }
266 run_test 7 "mkdir |X| contained create"
267
268 test_8() {
269     # make sure no side-effect from previous test.
270     rm -f $DIR/$tfile
271     replay_barrier $SINGLEMDS
272     multiop_bg_pause $DIR/$tfile mo_c || return 4
273     MULTIPID=$!
274     fail $SINGLEMDS
275     ls $DIR/$tfile
276     $CHECKSTAT -t file $DIR/$tfile || return 1
277     kill -USR1 $MULTIPID || return 2
278     wait $MULTIPID || return 3
279     rm $DIR/$tfile
280 }
281 run_test 8 "creat open |X| close"
282
283 test_9() {
284     replay_barrier $SINGLEMDS
285     mcreate $DIR/$tfile
286     local old_inum=`ls -i $DIR/$tfile | awk '{print $1}'`
287     fail $SINGLEMDS
288     local new_inum=`ls -i $DIR/$tfile | awk '{print $1}'`
289
290     echo " old_inum == $old_inum, new_inum == $new_inum"
291     if [ $old_inum -eq $new_inum  ] ;
292     then
293         echo " old_inum and new_inum match"
294     else
295         echo "!!!! old_inum and new_inum NOT match"
296         return 1
297     fi
298     rm $DIR/$tfile
299 }
300 run_test 9  "|X| create (same inum/gen)"
301
302 test_10() {
303     mcreate $DIR/$tfile
304     replay_barrier $SINGLEMDS
305     mv $DIR/$tfile $DIR/$tfile-2
306     rm -f $DIR/$tfile
307     fail $SINGLEMDS
308     $CHECKSTAT $DIR/$tfile && return 1
309     $CHECKSTAT $DIR/$tfile-2 ||return 2
310     rm $DIR/$tfile-2
311     return 0
312 }
313 run_test 10 "create |X| rename unlink"
314
315 test_11() {
316     mcreate $DIR/$tfile
317     echo "old" > $DIR/$tfile
318     mv $DIR/$tfile $DIR/$tfile-2
319     replay_barrier $SINGLEMDS
320     echo "new" > $DIR/$tfile
321     grep new $DIR/$tfile
322     grep old $DIR/$tfile-2
323     fail $SINGLEMDS
324     grep new $DIR/$tfile || return 1
325     grep old $DIR/$tfile-2 || return 2
326 }
327 run_test 11 "create open write rename |X| create-old-name read"
328
329 test_12() {
330     mcreate $DIR/$tfile
331     multiop_bg_pause $DIR/$tfile o_tSc || return 3
332     pid=$!
333     rm -f $DIR/$tfile
334     replay_barrier $SINGLEMDS
335     kill -USR1 $pid
336     wait $pid || return 1
337
338     fail $SINGLEMDS
339     [ -e $DIR/$tfile ] && return 2
340     return 0
341 }
342 run_test 12 "open, unlink |X| close"
343
344
345 # 1777 - replay open after committed chmod that would make
346 #        a regular open a failure
347 test_13() {
348     mcreate $DIR/$tfile
349     multiop_bg_pause $DIR/$tfile O_wc || return 3
350     pid=$!
351     chmod 0 $DIR/$tfile
352     $CHECKSTAT -p 0 $DIR/$tfile
353     replay_barrier $SINGLEMDS
354     fail $SINGLEMDS
355     kill -USR1 $pid
356     wait $pid || return 1
357
358     $CHECKSTAT -s 1 -p 0 $DIR/$tfile || return 2
359     rm $DIR/$tfile || return 4
360     return 0
361 }
362 run_test 13 "open chmod 0 |x| write close"
363
364 test_14() {
365     multiop_bg_pause $DIR/$tfile O_tSc || return 4
366     pid=$!
367     rm -f $DIR/$tfile
368     replay_barrier $SINGLEMDS
369     kill -USR1 $pid || return 1
370     wait $pid || return 2
371
372     fail $SINGLEMDS
373     [ -e $DIR/$tfile ] && return 3
374     return 0
375 }
376 run_test 14 "open(O_CREAT), unlink |X| close"
377
378 test_15() {
379     multiop_bg_pause $DIR/$tfile O_tSc || return 5
380     pid=$!
381     rm -f $DIR/$tfile
382     replay_barrier $SINGLEMDS
383     touch $DIR/g11 || return 1
384     kill -USR1 $pid
385     wait $pid || return 2
386
387     fail $SINGLEMDS
388     [ -e $DIR/$tfile ] && return 3
389     touch $DIR/h11 || return 4
390     return 0
391 }
392 run_test 15 "open(O_CREAT), unlink |X|  touch new, close"
393
394
395 test_16() {
396     replay_barrier $SINGLEMDS
397     mcreate $DIR/$tfile
398     munlink $DIR/$tfile
399     mcreate $DIR/$tfile-2
400     fail $SINGLEMDS
401     [ -e $DIR/$tfile ] && return 1
402     [ -e $DIR/$tfile-2 ] || return 2
403     munlink $DIR/$tfile-2 || return 3
404 }
405 run_test 16 "|X| open(O_CREAT), unlink, touch new,  unlink new"
406
407 test_17() {
408     replay_barrier $SINGLEMDS
409     multiop_bg_pause $DIR/$tfile O_c || return 4
410     pid=$!
411     fail $SINGLEMDS
412     kill -USR1 $pid || return 1
413     wait $pid || return 2
414     $CHECKSTAT -t file $DIR/$tfile || return 3
415     rm $DIR/$tfile
416 }
417 run_test 17 "|X| open(O_CREAT), |replay| close"
418
419 test_18() {
420     replay_barrier $SINGLEMDS
421     multiop_bg_pause $DIR/$tfile O_tSc || return 8
422     pid=$!
423     rm -f $DIR/$tfile
424     touch $DIR/$tfile-2 || return 1
425     echo "pid: $pid will close"
426     kill -USR1 $pid
427     wait $pid || return 2
428
429     fail $SINGLEMDS
430     [ -e $DIR/$tfile ] && return 3
431     [ -e $DIR/$tfile-2 ] || return 4
432     # this touch frequently fails
433     touch $DIR/$tfile-3 || return 5
434     munlink $DIR/$tfile-2 || return 6
435     munlink $DIR/$tfile-3 || return 7
436     return 0
437 }
438 run_test 18 "|X| open(O_CREAT), unlink, touch new, close, touch, unlink"
439
440 # bug 1855 (a simpler form of test_11 above)
441 test_19() {
442     replay_barrier $SINGLEMDS
443     mcreate $DIR/$tfile
444     echo "old" > $DIR/$tfile
445     mv $DIR/$tfile $DIR/$tfile-2
446     grep old $DIR/$tfile-2
447     fail $SINGLEMDS
448     grep old $DIR/$tfile-2 || return 2
449 }
450 run_test 19 "|X| mcreate, open, write, rename "
451
452 test_20a() {    # was test_20
453     replay_barrier $SINGLEMDS
454     multiop_bg_pause $DIR/$tfile O_tSc || return 3
455     pid=$!
456     rm -f $DIR/$tfile
457
458     fail $SINGLEMDS
459     kill -USR1 $pid
460     wait $pid || return 1
461     [ -e $DIR/$tfile ] && return 2
462     return 0
463 }
464 run_test 20a "|X| open(O_CREAT), unlink, replay, close (test mds_cleanup_orphans)"
465
466 test_20b() { # bug 10480
467     BEFOREUSED=`df -P $DIR | tail -1 | awk '{ print $3 }'`
468
469     dd if=/dev/zero of=$DIR/$tfile bs=4k count=10000 &
470     pid=$!
471     while [ ! -e $DIR/$tfile ] ; do
472         usleep 60                           # give dd a chance to start
473     done
474
475     lfs getstripe $DIR/$tfile || return 1
476     rm -f $DIR/$tfile || return 2       # make it an orphan
477     mds_evict_client
478     client_up || client_up || true    # reconnect
479
480     fail $SINGLEMDS                            # start orphan recovery
481     wait_recovery_complete $SINGLEMDS || error "MDS recovery not done"
482     wait_mds_ost_sync || return 3
483     AFTERUSED=`df -P $DIR | tail -1 | awk '{ print $3 }'`
484     log "before $BEFOREUSED, after $AFTERUSED"
485     [ $AFTERUSED -gt $((BEFOREUSED + 20)) ] && \
486         error "after $AFTERUSED > before $BEFOREUSED"
487     return 0
488 }
489 run_test 20b "write, unlink, eviction, replay, (test mds_cleanup_orphans)"
490
491 test_20c() { # bug 10480
492     multiop_bg_pause $DIR/$tfile Ow_c || return 1
493     pid=$!
494
495     ls -la $DIR/$tfile
496
497     mds_evict_client
498     client_up || client_up || true    # reconnect
499
500     kill -USR1 $pid
501     wait $pid || return 1
502     [ -s $DIR/$tfile ] || error "File was truncated"
503
504     return 0
505 }
506 run_test 20c "check that client eviction does not affect file content"
507
508 test_21() {
509     replay_barrier $SINGLEMDS
510     multiop_bg_pause $DIR/$tfile O_tSc || return 5
511     pid=$!
512     rm -f $DIR/$tfile
513     touch $DIR/g11 || return 1
514
515     fail $SINGLEMDS
516     kill -USR1 $pid
517     wait $pid || return 2
518     [ -e $DIR/$tfile ] && return 3
519     touch $DIR/h11 || return 4
520     return 0
521 }
522 run_test 21 "|X| open(O_CREAT), unlink touch new, replay, close (test mds_cleanup_orphans)"
523
524 test_22() {
525     multiop_bg_pause $DIR/$tfile O_tSc || return 3
526     pid=$!
527
528     replay_barrier $SINGLEMDS
529     rm -f $DIR/$tfile
530
531     fail $SINGLEMDS
532     kill -USR1 $pid
533     wait $pid || return 1
534     [ -e $DIR/$tfile ] && return 2
535     return 0
536 }
537 run_test 22 "open(O_CREAT), |X| unlink, replay, close (test mds_cleanup_orphans)"
538
539 test_23() {
540     multiop_bg_pause $DIR/$tfile O_tSc || return 5
541     pid=$!
542
543     replay_barrier $SINGLEMDS
544     rm -f $DIR/$tfile
545     touch $DIR/g11 || return 1
546
547     fail $SINGLEMDS
548     kill -USR1 $pid
549     wait $pid || return 2
550     [ -e $DIR/$tfile ] && return 3
551     touch $DIR/h11 || return 4
552     return 0
553 }
554 run_test 23 "open(O_CREAT), |X| unlink touch new, replay, close (test mds_cleanup_orphans)"
555
556 test_24() {
557     multiop_bg_pause $DIR/$tfile O_tSc || return 3
558     pid=$!
559
560     replay_barrier $SINGLEMDS
561     fail $SINGLEMDS
562     rm -f $DIR/$tfile
563     kill -USR1 $pid
564     wait $pid || return 1
565     [ -e $DIR/$tfile ] && return 2
566     return 0
567 }
568 run_test 24 "open(O_CREAT), replay, unlink, close (test mds_cleanup_orphans)"
569
570 test_25() {
571     multiop_bg_pause $DIR/$tfile O_tSc || return 3
572     pid=$!
573     rm -f $DIR/$tfile
574
575     replay_barrier $SINGLEMDS
576     fail $SINGLEMDS
577     kill -USR1 $pid
578     wait $pid || return 1
579     [ -e $DIR/$tfile ] && return 2
580     return 0
581 }
582 run_test 25 "open(O_CREAT), unlink, replay, close (test mds_cleanup_orphans)"
583
584 test_26() {
585     replay_barrier $SINGLEMDS
586     multiop_bg_pause $DIR/$tfile-1 O_tSc || return 5
587     pid1=$!
588     multiop_bg_pause $DIR/$tfile-2 O_tSc || return 6
589     pid2=$!
590     rm -f $DIR/$tfile-1
591     rm -f $DIR/$tfile-2
592     kill -USR1 $pid2
593     wait $pid2 || return 1
594
595     fail $SINGLEMDS
596     kill -USR1 $pid1
597     wait $pid1 || return 2
598     [ -e $DIR/$tfile-1 ] && return 3
599     [ -e $DIR/$tfile-2 ] && return 4
600     return 0
601 }
602 run_test 26 "|X| open(O_CREAT), unlink two, close one, replay, close one (test mds_cleanup_orphans)"
603
604 test_27() {
605     replay_barrier $SINGLEMDS
606     multiop_bg_pause $DIR/$tfile-1 O_tSc || return 5
607     pid1=$!
608     multiop_bg_pause $DIR/$tfile-2 O_tSc || return 6
609     pid2=$!
610     rm -f $DIR/$tfile-1
611     rm -f $DIR/$tfile-2
612
613     fail $SINGLEMDS
614     kill -USR1 $pid1
615     wait $pid1 || return 1
616     kill -USR1 $pid2
617     wait $pid2 || return 2
618     [ -e $DIR/$tfile-1 ] && return 3
619     [ -e $DIR/$tfile-2 ] && return 4
620     return 0
621 }
622 run_test 27 "|X| open(O_CREAT), unlink two, replay, close two (test mds_cleanup_orphans)"
623
624 test_28() {
625     multiop_bg_pause $DIR/$tfile-1 O_tSc || return 5
626     pid1=$!
627     multiop_bg_pause $DIR/$tfile-2 O_tSc || return 6
628     pid2=$!
629     replay_barrier $SINGLEMDS
630     rm -f $DIR/$tfile-1
631     rm -f $DIR/$tfile-2
632     kill -USR1 $pid2
633     wait $pid2 || return 1
634
635     fail $SINGLEMDS
636     kill -USR1 $pid1
637     wait $pid1 || return 2
638     [ -e $DIR/$tfile-1 ] && return 3
639     [ -e $DIR/$tfile-2 ] && return 4
640     return 0
641 }
642 run_test 28 "open(O_CREAT), |X| unlink two, close one, replay, close one (test mds_cleanup_orphans)"
643
644 test_29() {
645     multiop_bg_pause $DIR/$tfile-1 O_tSc || return 5
646     pid1=$!
647     multiop_bg_pause $DIR/$tfile-2 O_tSc || return 6
648     pid2=$!
649     replay_barrier $SINGLEMDS
650     rm -f $DIR/$tfile-1
651     rm -f $DIR/$tfile-2
652
653     fail $SINGLEMDS
654     kill -USR1 $pid1
655     wait $pid1 || return 1
656     kill -USR1 $pid2
657     wait $pid2 || return 2
658     [ -e $DIR/$tfile-1 ] && return 3
659     [ -e $DIR/$tfile-2 ] && return 4
660     return 0
661 }
662 run_test 29 "open(O_CREAT), |X| unlink two, replay, close two (test mds_cleanup_orphans)"
663
664 test_30() {
665     multiop_bg_pause $DIR/$tfile-1 O_tSc || return 5
666     pid1=$!
667     multiop_bg_pause $DIR/$tfile-2 O_tSc || return 6
668     pid2=$!
669     rm -f $DIR/$tfile-1
670     rm -f $DIR/$tfile-2
671
672     replay_barrier $SINGLEMDS
673     fail $SINGLEMDS
674     kill -USR1 $pid1
675     wait $pid1 || return 1
676     kill -USR1 $pid2
677     wait $pid2 || return 2
678     [ -e $DIR/$tfile-1 ] && return 3
679     [ -e $DIR/$tfile-2 ] && return 4
680     return 0
681 }
682 run_test 30 "open(O_CREAT) two, unlink two, replay, close two (test mds_cleanup_orphans)"
683
684 test_31() {
685     multiop_bg_pause $DIR/$tfile-1 O_tSc || return 5
686     pid1=$!
687     multiop_bg_pause $DIR/$tfile-2 O_tSc || return 6
688     pid2=$!
689     rm -f $DIR/$tfile-1
690
691     replay_barrier $SINGLEMDS
692     rm -f $DIR/$tfile-2
693     fail $SINGLEMDS
694     kill -USR1 $pid1
695     wait $pid1 || return 1
696     kill -USR1 $pid2
697     wait $pid2 || return 2
698     [ -e $DIR/$tfile-1 ] && return 3
699     [ -e $DIR/$tfile-2 ] && return 4
700     return 0
701 }
702 run_test 31 "open(O_CREAT) two, unlink one, |X| unlink one, close two (test mds_cleanup_orphans)"
703
704 # tests for bug 2104; completion without crashing is success.  The close is
705 # stale, but we always return 0 for close, so the app never sees it.
706 test_32() {
707     multiop_bg_pause $DIR/$tfile O_c || return 2
708     pid1=$!
709     multiop_bg_pause $DIR/$tfile O_c || return 3
710     pid2=$!
711     mds_evict_client
712     client_up || client_up || return 1
713     kill -USR1 $pid1
714     kill -USR1 $pid2
715     wait $pid1 || return 4
716     wait $pid2 || return 5
717     return 0
718 }
719 run_test 32 "close() notices client eviction; close() after client eviction"
720
721 test_33a() {
722     createmany -o $DIR/$tfile-%d 10
723     replay_barrier_nosync $SINGLEMDS
724     fail_abort $SINGLEMDS
725     # recreate shouldn't fail
726     createmany -o $DIR/$tfile--%d 10 || return 1
727     rm $DIR/$tfile-* -f
728     return 0
729 }
730 run_test 33a "fid seq shouldn't be reused after abort recovery"
731
732 test_33b() {
733     #define OBD_FAIL_SEQ_ALLOC                          0x1311
734     do_facet $SINGLEMDS "lctl set_param fail_loc=0x1311"
735
736     createmany -o $DIR/$tfile-%d 10
737     replay_barrier_nosync $SINGLEMDS
738     fail_abort $SINGLEMDS
739     # recreate shouldn't fail
740     createmany -o $DIR/$tfile--%d 10 || return 1
741     rm $DIR/$tfile-* -f
742     return 0
743 }
744 run_test 33b "test fid seq allocation"
745
746 test_34() {
747     multiop_bg_pause $DIR/$tfile O_c || return 2
748     pid=$!
749     rm -f $DIR/$tfile
750
751     replay_barrier $SINGLEMDS
752     fail_abort $SINGLEMDS
753     kill -USR1 $pid
754     wait $pid || return 3
755     [ -e $DIR/$tfile ] && return 1
756     sync
757     return 0
758 }
759 run_test 34 "abort recovery before client does replay (test mds_cleanup_orphans)"
760
761 # bug 2278 - generate one orphan on OST, then destroy it during recovery from llog
762 test_35() {
763     touch $DIR/$tfile
764
765 #define OBD_FAIL_MDS_REINT_NET_REP       0x119
766     do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000119"
767     rm -f $DIR/$tfile &
768     sleep 1
769     sync
770     sleep 1
771     # give a chance to remove from MDS
772     fail_abort $SINGLEMDS
773     $CHECKSTAT -t file $DIR/$tfile && return 1 || true
774 }
775 run_test 35 "test recovery from llog for unlink op"
776
777 # b=2432 resent cancel after replay uses wrong cookie,
778 # so don't resend cancels
779 test_36() {
780     replay_barrier $SINGLEMDS
781     touch $DIR/$tfile
782     checkstat $DIR/$tfile
783     facet_failover $SINGLEMDS
784     cancel_lru_locks mdc
785     if dmesg | grep "unknown lock cookie"; then
786         echo "cancel after replay failed"
787         return 1
788     fi
789 }
790 run_test 36 "don't resend cancel"
791
792 # b=2368
793 # directory orphans can't be unlinked from PENDING directory
794 test_37() {
795     rmdir $DIR/$tfile 2>/dev/null
796     multiop_bg_pause $DIR/$tfile dD_c || return 2
797     pid=$!
798     rmdir $DIR/$tfile
799
800     replay_barrier $SINGLEMDS
801     # clear the dmesg buffer so we only see errors from this recovery
802     dmesg -c >/dev/null
803     fail_abort $SINGLEMDS
804     kill -USR1 $pid
805     dmesg | grep  "mds_unlink_orphan.*error .* unlinking orphan" && return 1
806     wait $pid || return 3
807     sync
808     return 0
809 }
810 start_full_debug_logging
811 run_test 37 "abort recovery before client does replay (test mds_cleanup_orphans for directories)"
812 stop_full_debug_logging
813
814 test_38() {
815     createmany -o $DIR/$tfile-%d 800
816     unlinkmany $DIR/$tfile-%d 0 400
817     replay_barrier $SINGLEMDS
818     fail $SINGLEMDS
819     unlinkmany $DIR/$tfile-%d 400 400
820     sleep 2
821     $CHECKSTAT -t file $DIR/$tfile-* && return 1 || true
822 }
823 run_test 38 "test recovery from unlink llog (test llog_gen_rec) "
824
825 test_39() { # bug 4176
826     createmany -o $DIR/$tfile-%d 800
827     replay_barrier $SINGLEMDS
828     unlinkmany $DIR/$tfile-%d 0 400
829     fail $SINGLEMDS
830     unlinkmany $DIR/$tfile-%d 400 400
831     sleep 2
832     $CHECKSTAT -t file $DIR/$tfile-* && return 1 || true
833 }
834 run_test 39 "test recovery from unlink llog (test llog_gen_rec) "
835
836 count_ost_writes() {
837     lctl get_param -n osc.*.stats | awk -vwrites=0 '/ost_write/ { writes += $2 } END { print writes; }'
838 }
839
840 #b=2477,2532
841 test_40(){
842     $LCTL mark multiop $MOUNT/$tfile OS_c
843     multiop $MOUNT/$tfile OS_c  &
844     PID=$!
845     writeme -s $MOUNT/${tfile}-2 &
846     WRITE_PID=$!
847     sleep 1
848     facet_failover $SINGLEMDS
849 #define OBD_FAIL_MDS_CONNECT_NET         0x117
850     do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000117"
851     kill -USR1 $PID
852     stat1=`count_ost_writes`
853     sleep $TIMEOUT
854     stat2=`count_ost_writes`
855     echo "$stat1, $stat2"
856     if [ $stat1 -lt $stat2 ]; then
857        echo "writes continuing during recovery"
858        RC=0
859     else
860        echo "writes not continuing during recovery, bug 2477"
861        RC=4
862     fi
863     echo "waiting for writeme $WRITE_PID"
864     kill $WRITE_PID
865     wait $WRITE_PID
866
867     echo "waiting for multiop $PID"
868     wait $PID || return 2
869     do_facet client munlink $MOUNT/$tfile  || return 3
870     do_facet client munlink $MOUNT/${tfile}-2  || return 3
871     return $RC
872 }
873 run_test 40 "cause recovery in ptlrpc, ensure IO continues"
874
875
876 #b=2814
877 # make sure that a read to one osc doesn't try to double-unlock its page just
878 # because another osc is invalid.  trigger_group_io used to mistakenly return
879 # an error if any oscs were invalid even after having successfully put rpcs
880 # on valid oscs.  This was fatal if the caller was ll_readpage who unlocked
881 # the page, guarnateeing that the unlock from the RPC completion would
882 # assert on trying to unlock the unlocked page.
883 test_41() {
884     [ $OSTCOUNT -lt 2 ] && \
885         skip_env "skipping test 41: we don't have a second OST to test with" && \
886         return
887
888     local f=$MOUNT/$tfile
889     # make sure the start of the file is ost1
890     lfs setstripe $f -s $((128 * 1024)) -i 0
891     do_facet client dd if=/dev/zero of=$f bs=4k count=1 || return 3
892     cancel_lru_locks osc
893     # fail ost2 and read from ost1
894     local mdtosc=$(get_mdtosc_proc_path $SINGLEMDS $ost2_svc)
895     local osc2dev=$(do_facet $SINGLEMDS "lctl get_param -n devices" | \
896         grep $mdtosc | awk '{print $1}')
897     [ -z "$osc2dev" ] && echo "OST: $ost2_svc" && lctl get_param -n devices && return 4
898     do_facet $SINGLEMDS $LCTL --device $osc2dev deactivate || return 1
899     do_facet client dd if=$f of=/dev/null bs=4k count=1 || return 3
900     do_facet $SINGLEMDS $LCTL --device $osc2dev activate || return 2
901     return 0
902 }
903 run_test 41 "read from a valid osc while other oscs are invalid"
904
905 # test MDS recovery after ost failure
906 test_42() {
907     blocks=`df -P $MOUNT | tail -n 1 | awk '{ print $2 }'`
908     createmany -o $DIR/$tfile-%d 800
909     replay_barrier ost1
910     unlinkmany $DIR/$tfile-%d 0 400
911     debugsave
912     lctl set_param debug=-1
913     facet_failover ost1
914
915     # osc is evicted, fs is smaller (but only with failout OSTs (bug 7287)
916     #blocks_after=`df -P $MOUNT | tail -n 1 | awk '{ print $2 }'`
917     #[ $blocks_after -lt $blocks ] || return 1
918     echo wait for MDS to timeout and recover
919     sleep $((TIMEOUT * 2))
920     debugrestore
921     unlinkmany $DIR/$tfile-%d 400 400
922     $CHECKSTAT -t file $DIR/$tfile-* && return 2 || true
923 }
924 run_test 42 "recovery after ost failure"
925
926 # timeout in MDS/OST recovery RPC will LBUG MDS
927 test_43() { # bug 2530
928     remote_ost_nodsh && skip "remote OST with nodsh" && return 0
929
930     replay_barrier $SINGLEMDS
931
932     # OBD_FAIL_OST_CREATE_NET 0x204
933     do_facet ost1 "lctl set_param fail_loc=0x80000204"
934     fail $SINGLEMDS
935     sleep 10
936     do_facet ost1 "lctl set_param fail_loc=0"
937
938     return 0
939 }
940 run_test 43 "mds osc import failure during recovery; don't LBUG"
941
942 test_44a() { # was test_44
943     local at_max_saved=0
944
945     mdcdev=`lctl get_param -n devices | awk '/MDT0000-mdc-/ {print $1}'`
946     [ "$mdcdev" ] || return 2
947     [ $(echo $mdcdev | wc -w) -eq 1 ] || { echo $mdcdev=$mdcdev && return 3; }
948
949     # adaptive timeouts slow this way down
950     if at_is_enabled; then
951         at_max_saved=$(at_max_get mds)
952         at_max_set 40 mds
953     fi
954
955     for i in `seq 1 10`; do
956         echo "$i of 10 ($(date +%s))"
957         do_facet $SINGLEMDS "lctl get_param -n mdt.*.mdt.timeouts | grep service"
958         #define OBD_FAIL_TGT_CONN_RACE     0x701
959         do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000701"
960         # lctl below may fail, it is valid case
961         $LCTL --device $mdcdev recover
962         df $MOUNT
963     done
964     do_facet $SINGLEMDS "lctl set_param fail_loc=0"
965     [ $at_max_saved -ne 0 ] && at_max_set $at_max_saved mds
966     return 0
967 }
968 run_test 44a "race in target handle connect"
969
970 test_44b() {
971     local mdcdev=`lctl get_param -n devices | awk '/MDT0000-mdc-/ {print $1}'`
972     [ "$mdcdev" ] || return 2
973     [ $(echo $mdcdev | wc -w) -eq 1 ] || { echo $mdcdev=$mdcdev && return 3; }
974
975     for i in `seq 1 10`; do
976         echo "$i of 10 ($(date +%s))"
977         do_facet $SINGLEMDS "lctl get_param -n mdt.*.mdt.timeouts | grep service"
978         #define OBD_FAIL_TGT_DELAY_RECONNECT 0x704
979         do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000704"
980         # lctl below may fail, it is valid case
981         $LCTL --device $mdcdev recover
982         df $MOUNT
983     done
984     do_facet $SINGLEMDS "lctl set_param fail_loc=0"
985     return 0
986 }
987 run_test 44b "race in target handle connect"
988
989 # Handle failed close
990 test_45() {
991     mdcdev=`lctl get_param -n devices | awk '/MDT0000-mdc-/ {print $1}'`
992     [ "$mdcdev" ] || return 2
993     [ $(echo $mdcdev | wc -w) -eq 1 ] || { echo $mdcdev=$mdcdev && return 3; }
994
995     $LCTL --device $mdcdev recover || return 6 
996
997     multiop_bg_pause $DIR/$tfile O_c || return 1
998     pid=$!
999
1000     # This will cause the CLOSE to fail before even
1001     # allocating a reply buffer
1002     $LCTL --device $mdcdev deactivate || return 4
1003
1004     # try the close
1005     kill -USR1 $pid
1006     wait $pid || return 1
1007
1008     $LCTL --device $mdcdev activate || return 5
1009     sleep 1
1010
1011     $CHECKSTAT -t file $DIR/$tfile || return 2
1012     return 0
1013 }
1014 run_test 45 "Handle failed close"
1015
1016 test_46() {
1017     dmesg -c >/dev/null
1018     drop_reply "touch $DIR/$tfile"
1019     fail $SINGLEMDS
1020     # ironically, the previous test, 45, will cause a real forced close,
1021     # so just look for one for this test
1022     dmesg | grep -i "force closing client file handle for $tfile" && return 1
1023     return 0
1024 }
1025 run_test 46 "Don't leak file handle after open resend (3325)"
1026
1027 test_47() { # bug 2824
1028     remote_ost_nodsh && skip "remote OST with nodsh" && return 0
1029
1030     # create some files to make sure precreate has been done on all
1031     # OSTs. (just in case this test is run independently)
1032     createmany -o $DIR/$tfile 20  || return 1
1033
1034     # OBD_FAIL_OST_CREATE_NET 0x204
1035     fail ost1
1036     do_facet ost1 "lctl set_param fail_loc=0x80000204"
1037     client_up || return 2
1038
1039     # let the MDS discover the OST failure, attempt to recover, fail
1040     # and recover again.
1041     sleep $((3 * TIMEOUT))
1042
1043     # Without 2824, this createmany would hang
1044     createmany -o $DIR/$tfile 20 || return 3
1045     unlinkmany $DIR/$tfile 20 || return 4
1046
1047     do_facet ost1 "lctl set_param fail_loc=0"
1048     return 0
1049 }
1050 run_test 47 "MDS->OSC failure during precreate cleanup (2824)"
1051
1052 test_48() {
1053     remote_ost_nodsh && skip "remote OST with nodsh" && return 0
1054     [ "$OSTCOUNT" -lt "2" ] && skip_env "$OSTCOUNT < 2 OSTs -- skipping" && return
1055
1056     replay_barrier $SINGLEMDS
1057     createmany -o $DIR/$tfile 20  || return 1
1058     # OBD_FAIL_OST_EROFS 0x216
1059     facet_failover $SINGLEMDS
1060     do_facet ost1 "lctl set_param fail_loc=0x80000216"
1061     client_up || return 2
1062
1063     createmany -o $DIR/$tfile 20 20 || return 2
1064     unlinkmany $DIR/$tfile 40 || return 3
1065     return 0
1066 }
1067 run_test 48 "MDS->OSC failure during precreate cleanup (2824)"
1068
1069 test_50() {
1070     local mdtosc=$(get_mdtosc_proc_path $SINGLEMDS $ost1_svc) 
1071     local oscdev=$(do_facet $SINGLEMDS "lctl get_param -n devices" | \
1072         grep $mdtosc | awk '{print $1}')
1073     [ "$oscdev" ] || return 1
1074     do_facet $SINGLEMDS $LCTL --device $oscdev recover || return 2
1075     do_facet $SINGLEMDS $LCTL --device $oscdev recover || return 3
1076     # give the mds_lov_sync threads a chance to run
1077     sleep 5
1078 }
1079 run_test 50 "Double OSC recovery, don't LASSERT (3812)"
1080
1081 # b3764 timed out lock replay
1082 test_52() {
1083     touch $DIR/$tfile
1084     cancel_lru_locks mdc
1085
1086     multiop $DIR/$tfile s || return 1
1087     replay_barrier $SINGLEMDS
1088 #define OBD_FAIL_LDLM_REPLY              0x30c
1089     do_facet $SINGLEMDS "lctl set_param fail_loc=0x8000030c"
1090     fail $SINGLEMDS || return 2
1091     do_facet $SINGLEMDS "lctl set_param fail_loc=0x0"
1092
1093     $CHECKSTAT -t file $DIR/$tfile-* && return 3 || true
1094 }
1095 run_test 52 "time out lock replay (3764)"
1096
1097 # bug 3462 - simultaneous MDC requests
1098 test_53a() {
1099         cancel_lru_locks mdc    # cleanup locks from former test cases
1100         mkdir -p $DIR/${tdir}-1
1101         mkdir -p $DIR/${tdir}-2
1102         multiop $DIR/${tdir}-1/f O_c &
1103         close_pid=$!
1104         # give multiop a change to open
1105         sleep 1
1106
1107         #define OBD_FAIL_MDS_CLOSE_NET 0x115
1108         do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000115"
1109         kill -USR1 $close_pid
1110         cancel_lru_locks mdc    # force the close
1111         do_facet $SINGLEMDS "lctl set_param fail_loc=0"
1112
1113         mcreate $DIR/${tdir}-2/f || return 1
1114
1115         # close should still be here
1116         [ -d /proc/$close_pid ] || return 2
1117
1118         replay_barrier_nodf $SINGLEMDS
1119         fail $SINGLEMDS
1120         wait $close_pid || return 3
1121
1122         $CHECKSTAT -t file $DIR/${tdir}-1/f || return 4
1123         $CHECKSTAT -t file $DIR/${tdir}-2/f || return 5
1124         rm -rf $DIR/${tdir}-*
1125 }
1126 run_test 53a "|X| close request while two MDC requests in flight"
1127
1128 test_53b() {
1129         cancel_lru_locks mdc    # cleanup locks from former test cases
1130         rm -rf $DIR/${tdir}-1 $DIR/${tdir}-2
1131
1132         mkdir -p $DIR/${tdir}-1
1133         mkdir -p $DIR/${tdir}-2
1134         multiop_bg_pause $DIR/${tdir}-1/f O_c || return 6
1135         close_pid=$!
1136
1137         #define OBD_FAIL_MDS_REINT_NET 0x107
1138         do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000107"
1139         mcreate $DIR/${tdir}-2/f &
1140         open_pid=$!
1141         sleep 1
1142
1143         do_facet $SINGLEMDS "lctl set_param fail_loc=0"
1144         kill -USR1 $close_pid
1145         cancel_lru_locks mdc    # force the close
1146         wait $close_pid || return 1
1147         # open should still be here
1148         [ -d /proc/$open_pid ] || return 2
1149
1150         replay_barrier_nodf $SINGLEMDS
1151         fail $SINGLEMDS
1152         wait $open_pid || return 3
1153
1154         $CHECKSTAT -t file $DIR/${tdir}-1/f || return 4
1155         $CHECKSTAT -t file $DIR/${tdir}-2/f || return 5
1156         rm -rf $DIR/${tdir}-*
1157 }
1158 run_test 53b "|X| open request while two MDC requests in flight"
1159
1160 test_53c() {
1161         cancel_lru_locks mdc    # cleanup locks from former test cases
1162         rm -rf $DIR/${tdir}-1 $DIR/${tdir}-2
1163
1164         mkdir -p $DIR/${tdir}-1
1165         mkdir -p $DIR/${tdir}-2
1166         multiop $DIR/${tdir}-1/f O_c &
1167         close_pid=$!
1168
1169         #define OBD_FAIL_MDS_REINT_NET 0x107
1170         do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000107"
1171         mcreate $DIR/${tdir}-2/f &
1172         open_pid=$!
1173         sleep 1
1174
1175         #define OBD_FAIL_MDS_CLOSE_NET 0x115
1176         do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000115"
1177         kill -USR1 $close_pid
1178         cancel_lru_locks mdc    # force the close
1179
1180         #bz20647: make sure all pids are exists before failover
1181         [ -d /proc/$close_pid ] || error "close_pid doesn't exist"
1182         [ -d /proc/$open_pid ] || error "open_pid doesn't exists"
1183         replay_barrier_nodf $SINGLEMDS
1184         fail_nodf $SINGLEMDS
1185         wait $open_pid || return 1
1186         sleep 2
1187         # close should be gone
1188         [ -d /proc/$close_pid ] && return 2
1189         do_facet $SINGLEMDS "lctl set_param fail_loc=0"
1190
1191         $CHECKSTAT -t file $DIR/${tdir}-1/f || return 3
1192         $CHECKSTAT -t file $DIR/${tdir}-2/f || return 4
1193         rm -rf $DIR/${tdir}-*
1194 }
1195 run_test 53c "|X| open request and close request while two MDC requests in flight"
1196
1197 test_53d() {
1198         cancel_lru_locks mdc    # cleanup locks from former test cases
1199         rm -rf $DIR/${tdir}-1 $DIR/${tdir}-2
1200
1201         mkdir -p $DIR/${tdir}-1
1202         mkdir -p $DIR/${tdir}-2
1203         multiop $DIR/${tdir}-1/f O_c &
1204         close_pid=$!
1205         # give multiop a chance to open
1206         sleep 1
1207
1208         #define OBD_FAIL_MDS_CLOSE_NET_REP 0x13b
1209         do_facet $SINGLEMDS "lctl set_param fail_loc=0x8000013b"
1210         kill -USR1 $close_pid
1211         cancel_lru_locks mdc    # force the close
1212         do_facet $SINGLEMDS "lctl set_param fail_loc=0"
1213         mcreate $DIR/${tdir}-2/f || return 1
1214
1215         # close should still be here
1216         [ -d /proc/$close_pid ] || return 2
1217         fail $SINGLEMDS
1218         wait $close_pid || return 3
1219
1220         $CHECKSTAT -t file $DIR/${tdir}-1/f || return 4
1221         $CHECKSTAT -t file $DIR/${tdir}-2/f || return 5
1222         rm -rf $DIR/${tdir}-*
1223 }
1224 run_test 53d "|X| close reply while two MDC requests in flight"
1225
1226 test_53e() {
1227         cancel_lru_locks mdc    # cleanup locks from former test cases
1228         rm -rf $DIR/${tdir}-1 $DIR/${tdir}-2
1229
1230         mkdir -p $DIR/${tdir}-1
1231         mkdir -p $DIR/${tdir}-2
1232         multiop $DIR/${tdir}-1/f O_c &
1233         close_pid=$!
1234
1235         #define OBD_FAIL_MDS_REINT_NET_REP 0x119
1236         do_facet $SINGLEMDS "lctl set_param fail_loc=0x119"
1237         mcreate $DIR/${tdir}-2/f &
1238         open_pid=$!
1239         sleep 1
1240
1241         do_facet $SINGLEMDS "lctl set_param fail_loc=0"
1242         kill -USR1 $close_pid
1243         cancel_lru_locks mdc    # force the close
1244         wait $close_pid || return 1
1245         # open should still be here
1246         [ -d /proc/$open_pid ] || return 2
1247
1248         replay_barrier_nodf $SINGLEMDS
1249         fail $SINGLEMDS
1250         wait $open_pid || return 3
1251
1252         $CHECKSTAT -t file $DIR/${tdir}-1/f || return 4
1253         $CHECKSTAT -t file $DIR/${tdir}-2/f || return 5
1254         rm -rf $DIR/${tdir}-*
1255 }
1256 run_test 53e "|X| open reply while two MDC requests in flight"
1257
1258 test_53f() {
1259         cancel_lru_locks mdc    # cleanup locks from former test cases
1260         rm -rf $DIR/${tdir}-1 $DIR/${tdir}-2
1261
1262         mkdir -p $DIR/${tdir}-1
1263         mkdir -p $DIR/${tdir}-2
1264         multiop $DIR/${tdir}-1/f O_c &
1265         close_pid=$!
1266
1267         #define OBD_FAIL_MDS_REINT_NET_REP 0x119
1268         do_facet $SINGLEMDS "lctl set_param fail_loc=0x119"
1269         mcreate $DIR/${tdir}-2/f &
1270         open_pid=$!
1271         sleep 1
1272
1273         #define OBD_FAIL_MDS_CLOSE_NET_REP 0x13b
1274         do_facet $SINGLEMDS "lctl set_param fail_loc=0x8000013b"
1275         kill -USR1 $close_pid
1276         cancel_lru_locks mdc    # force the close
1277
1278         #bz20647: make sure all pids are exists before failover
1279         [ -d /proc/$close_pid ] || error "close_pid doesn't exist"
1280         [ -d /proc/$open_pid ] || error "open_pid doesn't exists"
1281         replay_barrier_nodf $SINGLEMDS
1282         fail_nodf $SINGLEMDS
1283         wait $open_pid || return 1
1284         sleep 2
1285         # close should be gone
1286         [ -d /proc/$close_pid ] && return 2
1287         do_facet $SINGLEMDS "lctl set_param fail_loc=0"
1288
1289         $CHECKSTAT -t file $DIR/${tdir}-1/f || return 3
1290         $CHECKSTAT -t file $DIR/${tdir}-2/f || return 4
1291         rm -rf $DIR/${tdir}-*
1292 }
1293 run_test 53f "|X| open reply and close reply while two MDC requests in flight"
1294
1295 test_53g() {
1296         cancel_lru_locks mdc    # cleanup locks from former test cases
1297         rm -rf $DIR/${tdir}-1 $DIR/${tdir}-2
1298
1299         mkdir -p $DIR/${tdir}-1
1300         mkdir -p $DIR/${tdir}-2
1301         multiop $DIR/${tdir}-1/f O_c &
1302         close_pid=$!
1303
1304         #define OBD_FAIL_MDS_REINT_NET_REP 0x119
1305         do_facet $SINGLEMDS "lctl set_param fail_loc=0x119"
1306         mcreate $DIR/${tdir}-2/f &
1307         open_pid=$!
1308         sleep 1
1309
1310         #define OBD_FAIL_MDS_CLOSE_NET 0x115
1311         do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000115"
1312         kill -USR1 $close_pid
1313         cancel_lru_locks mdc    # force the close
1314         do_facet $SINGLEMDS "lctl set_param fail_loc=0"
1315
1316         #bz20647: make sure all pids are exists before failover
1317         [ -d /proc/$close_pid ] || error "close_pid doesn't exist"
1318         [ -d /proc/$open_pid ] || error "open_pid doesn't exists"
1319         replay_barrier_nodf $SINGLEMDS
1320         fail_nodf $SINGLEMDS
1321         wait $open_pid || return 1
1322         sleep 2
1323         # close should be gone
1324         [ -d /proc/$close_pid ] && return 2
1325
1326         $CHECKSTAT -t file $DIR/${tdir}-1/f || return 3
1327         $CHECKSTAT -t file $DIR/${tdir}-2/f || return 4
1328         rm -rf $DIR/${tdir}-*
1329 }
1330 run_test 53g "|X| drop open reply and close request while close and open are both in flight"
1331
1332 test_53h() {
1333         cancel_lru_locks mdc    # cleanup locks from former test cases
1334         rm -rf $DIR/${tdir}-1 $DIR/${tdir}-2
1335
1336         mkdir -p $DIR/${tdir}-1
1337         mkdir -p $DIR/${tdir}-2
1338         multiop $DIR/${tdir}-1/f O_c &
1339         close_pid=$!
1340
1341         #define OBD_FAIL_MDS_REINT_NET 0x107
1342         do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000107"
1343         mcreate $DIR/${tdir}-2/f &
1344         open_pid=$!
1345         sleep 1
1346
1347         #define OBD_FAIL_MDS_CLOSE_NET_REP 0x13b
1348         do_facet $SINGLEMDS "lctl set_param fail_loc=0x8000013b"
1349         kill -USR1 $close_pid
1350         cancel_lru_locks mdc    # force the close
1351         sleep 1
1352
1353         #bz20647: make sure all pids are exists before failover
1354         [ -d /proc/$close_pid ] || error "close_pid doesn't exist"
1355         [ -d /proc/$open_pid ] || error "open_pid doesn't exists"
1356         replay_barrier_nodf $SINGLEMDS
1357         fail_nodf $SINGLEMDS
1358         wait $open_pid || return 1
1359         sleep 2
1360         # close should be gone
1361         [ -d /proc/$close_pid ] && return 2
1362         do_facet $SINGLEMDS "lctl set_param fail_loc=0"
1363
1364         $CHECKSTAT -t file $DIR/${tdir}-1/f || return 3
1365         $CHECKSTAT -t file $DIR/${tdir}-2/f || return 4
1366         rm -rf $DIR/${tdir}-*
1367 }
1368 run_test 53h "|X| open request and close reply while two MDC requests in flight"
1369
1370 #b_cray 54 "|X| open request and close reply while two MDC requests in flight"
1371
1372 #b3761 ASSERTION(hash != 0) failed
1373 test_55() {
1374 # OBD_FAIL_MDS_OPEN_CREATE | OBD_FAIL_ONCE
1375     do_facet $SINGLEMDS "lctl set_param fail_loc=0x8000012b"
1376     touch $DIR/$tfile &
1377     # give touch a chance to run
1378     sleep 5
1379     do_facet $SINGLEMDS "lctl set_param fail_loc=0x0"
1380     rm $DIR/$tfile
1381     return 0
1382 }
1383 run_test 55 "let MDS_CHECK_RESENT return the original return code instead of 0"
1384
1385 #b3440 ASSERTION(rec->ur_fid2->id) failed
1386 test_56() {
1387     ln -s foo $DIR/$tfile
1388     replay_barrier $SINGLEMDS
1389     #drop_reply "cat $DIR/$tfile"
1390     fail $SINGLEMDS
1391     sleep 10
1392 }
1393 run_test 56 "don't replay a symlink open request (3440)"
1394
1395 #recovery one mds-ost setattr from llog
1396 test_57() {
1397 #define OBD_FAIL_MDS_OST_SETATTR       0x12c
1398     do_facet $SINGLEMDS "lctl set_param fail_loc=0x8000012c"
1399     touch $DIR/$tfile
1400     replay_barrier $SINGLEMDS
1401     fail $SINGLEMDS
1402     sleep 1
1403     $CHECKSTAT -t file $DIR/$tfile || return 1
1404     do_facet $SINGLEMDS "lctl set_param fail_loc=0x0"
1405     rm $DIR/$tfile
1406 }
1407 run_test 57 "test recovery from llog for setattr op"
1408
1409 #recovery many mds-ost setattr from llog
1410 test_58a() {
1411     mkdir -p $DIR/$tdir
1412 #define OBD_FAIL_MDS_OST_SETATTR       0x12c
1413     do_facet $SINGLEMDS "lctl set_param fail_loc=0x8000012c"
1414     createmany -o $DIR/$tdir/$tfile-%d 2500
1415     replay_barrier $SINGLEMDS
1416     fail $SINGLEMDS
1417     sleep 2
1418     $CHECKSTAT -t file $DIR/$tdir/$tfile-* >/dev/null || return 1
1419     do_facet $SINGLEMDS "lctl set_param fail_loc=0x0"
1420     unlinkmany $DIR/$tdir/$tfile-%d 2500
1421     rmdir $DIR/$tdir
1422 }
1423 run_test 58a "test recovery from llog for setattr op (test llog_gen_rec)"
1424
1425 test_58b() {
1426     mount_client $MOUNT2
1427     mkdir -p $DIR/$tdir
1428     touch $DIR/$tdir/$tfile
1429     replay_barrier $SINGLEMDS
1430     setfattr -n trusted.foo -v bar $DIR/$tdir/$tfile
1431     fail $SINGLEMDS
1432     VAL=`getfattr --absolute-names --only-value -n trusted.foo $MOUNT2/$tdir/$tfile`
1433     [ x$VAL = x"bar" ] || return 1
1434     rm -f $DIR/$tdir/$tfile
1435     rmdir $DIR/$tdir
1436     zconf_umount `hostname` $MOUNT2
1437 }
1438 run_test 58b "test replay of setxattr op"
1439
1440 test_58c() { # bug 16570
1441         mount_client $MOUNT2
1442         mkdir -p $DIR/$tdir
1443         touch $DIR/$tdir/$tfile
1444         drop_request "setfattr -n trusted.foo -v bar $DIR/$tdir/$tfile" || \
1445                 return 1
1446         VAL=`getfattr --absolute-names --only-value -n trusted.foo $MOUNT2/$tdir/$tfile`
1447         [ x$VAL = x"bar" ] || return 2
1448         drop_reint_reply "setfattr -n trusted.foo1 -v bar1 $DIR/$tdir/$tfile" || \
1449                 return 3
1450         VAL=`getfattr --absolute-names --only-value -n trusted.foo1 $MOUNT2/$tdir/$tfile`
1451         [ x$VAL = x"bar1" ] || return 4
1452         rm -f $DIR/$tdir/$tfile
1453         rmdir $DIR/$tdir
1454         zconf_umount `hostname` $MOUNT2
1455 }
1456 run_test 58c "resend/reconstruct setxattr op"
1457
1458 # log_commit_thread vs filter_destroy race used to lead to import use after free
1459 # bug 11658
1460 test_59() {
1461     remote_ost_nodsh && skip "remote OST with nodsh" && return 0
1462
1463     mkdir -p $DIR/$tdir
1464     createmany -o $DIR/$tdir/$tfile-%d 200
1465     sync
1466     unlinkmany $DIR/$tdir/$tfile-%d 200
1467 #define OBD_FAIL_PTLRPC_DELAY_RECOV       0x507
1468     do_facet ost1 "lctl set_param fail_loc=0x507"
1469     fail ost1
1470     fail $SINGLEMDS
1471     do_facet ost1 "lctl set_param fail_loc=0x0"
1472     sleep 20
1473     rmdir $DIR/$tdir
1474 }
1475 run_test 59 "test log_commit_thread vs filter_destroy race"
1476
1477 # race between add unlink llog vs cat log init in post_recovery (only for b1_6)
1478 # bug 12086: should no oops and No ctxt error for this test
1479 test_60() {
1480     mkdir -p $DIR/$tdir
1481     createmany -o $DIR/$tdir/$tfile-%d 200
1482     replay_barrier $SINGLEMDS
1483     unlinkmany $DIR/$tdir/$tfile-%d 0 100
1484     fail $SINGLEMDS
1485     unlinkmany $DIR/$tdir/$tfile-%d 100 100
1486     local no_ctxt=`dmesg | grep "No ctxt"`
1487     [ -z "$no_ctxt" ] || error "ctxt is not initialized in recovery"
1488 }
1489 run_test 60 "test llog post recovery init vs llog unlink"
1490
1491 #test race  llog recovery thread vs llog cleanup
1492 test_61a() {    # was test_61
1493     remote_ost_nodsh && skip "remote OST with nodsh" && return 0
1494
1495     mkdir -p $DIR/$tdir
1496     createmany -o $DIR/$tdir/$tfile-%d 800
1497     replay_barrier ost1
1498 #   OBD_FAIL_OST_LLOG_RECOVERY_TIMEOUT 0x221
1499     unlinkmany $DIR/$tdir/$tfile-%d 800
1500     set_nodes_failloc "$(osts_nodes)" 0x80000221
1501     facet_failover ost1
1502     sleep 10
1503     fail ost1
1504     sleep 30
1505     set_nodes_failloc "$(osts_nodes)" 0x0
1506
1507     $CHECKSTAT -t file $DIR/$tdir/$tfile-* && return 1
1508     rmdir $DIR/$tdir
1509 }
1510 run_test 61a "test race llog recovery vs llog cleanup"
1511
1512 #test race  mds llog sync vs llog cleanup
1513 test_61b() {
1514 #   OBD_FAIL_MDS_LLOG_SYNC_TIMEOUT 0x13a
1515     do_facet $SINGLEMDS "lctl set_param fail_loc=0x8000013a"
1516     facet_failover $SINGLEMDS
1517     sleep 10
1518     fail $SINGLEMDS
1519     do_facet client dd if=/dev/zero of=$DIR/$tfile bs=4k count=1 || return 1
1520 }
1521 run_test 61b "test race mds llog sync vs llog cleanup"
1522
1523 #test race  cancel cookie cb vs llog cleanup
1524 test_61c() {
1525     remote_ost_nodsh && skip "remote OST with nodsh" && return 0
1526
1527 #   OBD_FAIL_OST_CANCEL_COOKIE_TIMEOUT 0x222
1528     touch $DIR/$tfile
1529     set_nodes_failloc "$(osts_nodes)" 0x80000222
1530     rm $DIR/$tfile
1531     sleep 10
1532     fail ost1
1533     set_nodes_failloc "$(osts_nodes)" 0x0
1534 }
1535 run_test 61c "test race mds llog sync vs llog cleanup"
1536
1537 test_61d() { # bug 16002 # bug 17466
1538     shutdown_facet $SINGLEMDS
1539 #define OBD_FAIL_OBD_LLOG_SETUP        0x605
1540     do_facet $SINGLEMDS "lctl set_param fail_loc=0x605"
1541     start $SINGLEMDS `mdsdevname 1` $MDS_MOUNT_OPTS && error "mds start should have failed"
1542     do_facet $SINGLEMDS "lctl set_param fail_loc=0"
1543     start $SINGLEMDS `mdsdevname 1` $MDS_MOUNT_OPTS || error "cannot restart mds"
1544 }
1545 run_test 61d "error in llog_setup should cleanup the llog context correctly"
1546
1547 test_62() { # Bug 15756 - don't mis-drop resent replay
1548     mkdir -p $DIR/$tdir
1549     replay_barrier $SINGLEMDS
1550     createmany -o $DIR/$tdir/$tfile- 25
1551 #define OBD_FAIL_TGT_REPLAY_DROP         0x707
1552     do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000707"
1553     fail $SINGLEMDS
1554     do_facet $SINGLEMDS "lctl set_param fail_loc=0"
1555     unlinkmany $DIR/$tdir/$tfile- 25 || return 2
1556     return 0
1557 }
1558 run_test 62 "don't mis-drop resent replay"
1559
1560 #Adaptive Timeouts (bug 3055)
1561 AT_MAX_SET=0
1562
1563 at_cleanup () {
1564     local var
1565     local facet
1566     local at_new
1567
1568     echo "Cleaning up AT ..."
1569     if [ -n "$ATOLDBASE" ]; then
1570         local at_history=$($LCTL get_param -n at_history)
1571         do_facet mds "lctl set_param at_history=$at_history" || true
1572         do_facet ost1 "lctl set_param at_history=$at_history" || true
1573     fi
1574
1575     if [ $AT_MAX_SET -ne 0 ]; then
1576         for facet in mds client ost; do
1577             var=AT_MAX_SAVE_${facet}
1578             echo restore AT on $facet to saved value ${!var}
1579             at_max_set ${!var} $facet
1580             at_new=$(at_max_get $facet)
1581             echo Restored AT value on $facet $at_new
1582             [ $at_new -eq ${!var} ] || \
1583             error "$facet : AT value was not restored SAVED ${!var} NEW $at_new"
1584         done
1585     fi
1586 }
1587
1588 at_start()
1589 {
1590     local at_max_new=600
1591
1592     # Save at_max original values
1593     local facet
1594     if [ $AT_MAX_SET -eq 0 ]; then
1595         # Suppose that all osts have the same at_max
1596         for facet in mds client ost; do
1597             eval AT_MAX_SAVE_${facet}=$(at_max_get $facet)
1598         done
1599     fi
1600     local at_max
1601     for facet in mds client ost; do
1602         at_max=$(at_max_get $facet)
1603         if [ $at_max -ne $at_max_new ]; then
1604             echo "AT value on $facet is $at_max, set it by force temporarily to $at_max_new"
1605             at_max_set $at_max_new $facet
1606             AT_MAX_SET=1
1607         fi
1608     done
1609
1610     if [ -z "$ATOLDBASE" ]; then
1611         ATOLDBASE=$(do_facet mds "lctl get_param -n at_history")
1612         # speed up the timebase so we can check decreasing AT
1613         do_facet mds "lctl set_param at_history=8" || true
1614         do_facet ost1 "lctl set_param at_history=8" || true
1615
1616         # sleep for a while to cool down, should be > 8s and also allow
1617         # at least one ping to be sent. simply use TIMEOUT to be safe.
1618         sleep $TIMEOUT
1619     fi
1620 }
1621
1622 test_65a() #bug 3055
1623 {
1624     remote_ost_nodsh && skip "remote OST with nodsh" && return 0
1625
1626     at_start || return 0
1627     $LCTL dk > /dev/null
1628     debugsave
1629     sysctl -w lnet.debug="+other"
1630     # Slow down a request to the current service time, this is critical
1631     # because previous tests may have caused this value to increase.
1632     REQ_DELAY=`lctl get_param -n mdc.${FSNAME}-MDT0000-mdc-*.timeouts |
1633                awk '/portal 12/ {print $5}'`
1634     REQ_DELAY=$((${REQ_DELAY} + ${REQ_DELAY} / 4 + 5))
1635
1636     do_facet mds lctl set_param fail_val=$((${REQ_DELAY} * 1000))
1637 #define OBD_FAIL_PTLRPC_PAUSE_REQ        0x50a
1638     do_facet mds sysctl -w lustre.fail_loc=0x8000050a
1639     createmany -o $DIR/$tfile 10 > /dev/null
1640     unlinkmany $DIR/$tfile 10 > /dev/null
1641     # check for log message
1642     $LCTL dk | grep "Early reply #" || error "No early reply"
1643     debugrestore
1644     # client should show REQ_DELAY estimates
1645     lctl get_param -n mdc.${FSNAME}-MDT0000-mdc-*.timeouts | grep portal
1646     sleep 9
1647     lctl get_param -n mdc.${FSNAME}-MDT0000-mdc-*.timeouts | grep portal
1648 }
1649 run_test 65a "AT: verify early replies"
1650
1651 test_65b() #bug 3055
1652 {
1653     remote_ost_nodsh && skip "remote OST with nodsh" && return 0
1654
1655     at_start || return 0
1656     # turn on D_ADAPTTO
1657     debugsave
1658     sysctl -w lnet.debug="other trace"
1659     $LCTL dk > /dev/null
1660     # Slow down a request to the current service time, this is critical
1661     # because previous tests may have caused this value to increase.
1662     lfs setstripe $DIR/$tfile --index=0 --count=1
1663     multiop $DIR/$tfile Ow1yc
1664     REQ_DELAY=`lctl get_param -n osc.${FSNAME}-OST0000-osc-*.timeouts |
1665                awk '/portal 6/ {print $5}'`
1666     REQ_DELAY=$((${REQ_DELAY} + ${REQ_DELAY} / 4 + 5))
1667
1668     do_facet ost1 lctl set_param fail_val=${REQ_DELAY}
1669 #define OBD_FAIL_OST_BRW_PAUSE_PACK      0x224
1670     do_facet ost1 sysctl -w lustre.fail_loc=0x224
1671
1672     rm -f $DIR/$tfile
1673     lfs setstripe $DIR/$tfile --index=0 --count=1
1674     # force some real bulk transfer
1675     multiop $DIR/$tfile oO_CREAT:O_RDWR:O_SYNC:w4096c
1676
1677     do_facet ost1 sysctl -w lustre.fail_loc=0
1678     # check for log message
1679     $LCTL dk | grep "Early reply #" || error "No early reply"
1680     debugrestore
1681     # client should show REQ_DELAY estimates
1682     lctl get_param -n osc.${FSNAME}-OST0000-osc-*.timeouts | grep portal
1683 }
1684 run_test 65b "AT: verify early replies on packed reply / bulk"
1685
1686 test_66a() #bug 3055
1687 {
1688     remote_ost_nodsh && skip "remote OST with nodsh" && return 0
1689
1690     at_start || return 0
1691     lctl get_param -n mdc.${FSNAME}-MDT0000-mdc-*.timeouts | grep "portal 12"
1692     # adjust 5s at a time so no early reply is sent (within deadline)
1693     do_facet mds "sysctl -w lustre.fail_val=5000"
1694 #define OBD_FAIL_PTLRPC_PAUSE_REQ        0x50a
1695     do_facet mds "sysctl -w lustre.fail_loc=0x8000050a"
1696     createmany -o $DIR/$tfile 20 > /dev/null
1697     unlinkmany $DIR/$tfile 20 > /dev/null
1698     lctl get_param -n mdc.${FSNAME}-MDT0000-mdc-*.timeouts | grep "portal 12"
1699     do_facet mds "sysctl -w lustre.fail_val=10000"
1700     do_facet mds "sysctl -w lustre.fail_loc=0x8000050a"
1701     createmany -o $DIR/$tfile 20 > /dev/null
1702     unlinkmany $DIR/$tfile 20 > /dev/null
1703     lctl get_param -n mdc.${FSNAME}-MDT0000-mdc-*.timeouts | grep "portal 12"
1704     do_facet mds "sysctl -w lustre.fail_loc=0"
1705     sleep 9
1706     createmany -o $DIR/$tfile 20 > /dev/null
1707     unlinkmany $DIR/$tfile 20 > /dev/null
1708     lctl get_param -n mdc.${FSNAME}-MDT0000-mdc-*.timeouts | grep "portal 12"
1709     CUR=$(lctl get_param -n mdc.${FSNAME}-MDT0000-mdc-*.timeouts | awk '/portal 12/ {print $5}')
1710     WORST=$(lctl get_param -n mdc.${FSNAME}-MDT0000-mdc-*.timeouts | awk '/portal 12/ {print $7}')
1711     echo "Current MDT timeout $CUR, worst $WORST"
1712     [ $CUR -lt $WORST ] || error "Current $CUR should be less than worst $WORST"
1713 }
1714 run_test 66a "AT: verify MDT service time adjusts with no early replies"
1715
1716 test_66b() #bug 3055
1717 {
1718     remote_ost_nodsh && skip "remote OST with nodsh" && return 0
1719
1720     at_start || return 0
1721     ORIG=$(lctl get_param -n mdc.${FSNAME}-*.timeouts | awk '/network/ {print $4}')
1722     sysctl -w lustre.fail_val=$(($ORIG + 5))
1723 #define OBD_FAIL_PTLRPC_PAUSE_REP      0x50c
1724     sysctl -w lustre.fail_loc=0x50c
1725     ls $DIR/$tfile > /dev/null 2>&1
1726     sysctl -w lustre.fail_loc=0
1727     CUR=$(lctl get_param -n mdc.${FSNAME}-*.timeouts | awk '/network/ {print $4}')
1728     WORST=$(lctl get_param -n mdc.${FSNAME}-*.timeouts | awk '/network/ {print $6}')
1729     echo "network timeout orig $ORIG, cur $CUR, worst $WORST"
1730     [ $WORST -gt $ORIG ] || error "Worst $WORST should be worse than orig $ORIG"
1731 }
1732 run_test 66b "AT: verify net latency adjusts"
1733
1734 test_67a() #bug 3055
1735 {
1736     remote_ost_nodsh && skip "remote OST with nodsh" && return 0
1737
1738     at_start || return 0
1739     CONN1=$(lctl get_param -n osc.*.stats | awk '/_connect/ {total+=$2} END {print total}')
1740     # sleeping threads may drive values above this
1741     do_facet ost1 "sysctl -w lustre.fail_val=400"
1742 #define OBD_FAIL_PTLRPC_PAUSE_REQ    0x50a
1743     do_facet ost1 "sysctl -w lustre.fail_loc=0x50a"
1744     createmany -o $DIR/$tfile 20 > /dev/null
1745     unlinkmany $DIR/$tfile 20 > /dev/null
1746     do_facet ost1 "sysctl -w lustre.fail_loc=0"
1747     CONN2=$(lctl get_param -n osc.*.stats | awk '/_connect/ {total+=$2} END {print total}')
1748     ATTEMPTS=$(($CONN2 - $CONN1))
1749     echo "$ATTEMPTS osc reconnect attempts on gradual slow"
1750     [ $ATTEMPTS -gt 0 ] && error_ignore 13721 "AT should have prevented reconnect"
1751     return 0
1752 }
1753 run_test 67a "AT: verify slow request processing doesn't induce reconnects"
1754
1755 test_67b() #bug 3055
1756 {
1757     remote_ost_nodsh && skip "remote OST with nodsh" && return 0
1758
1759     at_start || return 0
1760     CONN1=$(lctl get_param -n osc.*.stats | awk '/_connect/ {total+=$2} END {print total}')
1761
1762     # exhaust precreations on ost1
1763     local OST=$(lfs osts | grep ^0": " | awk '{print $2}' | sed -e 's/_UUID$//')
1764     local mdtosc=$(get_mdtosc_proc_path mds $OST)
1765     local last_id=$(do_facet mds lctl get_param -n \
1766         osc.$mdtosc.prealloc_last_id)
1767     local next_id=$(do_facet mds lctl get_param -n \
1768         osc.$mdtosc.prealloc_next_id)
1769
1770     mkdir -p $DIR/$tdir/${OST}
1771     lfs setstripe $DIR/$tdir/${OST} -o 0 -c 1 || error "setstripe"
1772     echo "Creating to objid $last_id on ost $OST..."
1773 #define OBD_FAIL_OST_PAUSE_CREATE        0x223
1774     do_facet ost1 "sysctl -w lustre.fail_val=20000"
1775     do_facet ost1 "sysctl -w lustre.fail_loc=0x80000223"
1776     createmany -o $DIR/$tdir/${OST}/f $next_id $((last_id - next_id + 2))
1777
1778     client_reconnect
1779     do_facet ost1 "lctl get_param -n ost.OSS.ost_create.timeouts"
1780     log "phase 2"
1781     CONN2=$(lctl get_param -n osc.*.stats | awk '/_connect/ {total+=$2} END {print total}')
1782     ATTEMPTS=$(($CONN2 - $CONN1))
1783     echo "$ATTEMPTS osc reconnect attempts on instant slow"
1784     # do it again; should not timeout
1785     do_facet ost1 "sysctl -w lustre.fail_loc=0x80000223"
1786     cp /etc/profile $DIR/$tfile || error "cp failed"
1787     do_facet ost1 "sysctl -w lustre.fail_loc=0"
1788     client_reconnect
1789     do_facet ost1 "lctl get_param -n ost.OSS.ost_create.timeouts"
1790     CONN3=$(lctl get_param -n osc.*.stats | awk '/_connect/ {total+=$2} END {print total}')
1791     ATTEMPTS=$(($CONN3 - $CONN2))
1792     echo "$ATTEMPTS osc reconnect attempts on 2nd slow"
1793     [ $ATTEMPTS -gt 0 ] && error "AT should have prevented reconnect"
1794     return 0
1795 }
1796 run_test 67b "AT: verify instant slowdown doesn't induce reconnects"
1797
1798 test_68 () #bug 13813
1799 {
1800     remote_ost_nodsh && skip "remote OST with nodsh" && return 0
1801
1802     at_start || return 0
1803     local ldlm_enqueue_min=$(find /sys -name ldlm_enqueue_min)
1804     [ -z "$ldlm_enqueue_min" ] && skip "missing /sys/.../ldlm_enqueue_min" && return 0
1805     local ldlm_enqueue_min_r=$(do_facet ost1 "find /sys -name ldlm_enqueue_min")
1806     [ -z "$ldlm_enqueue_min_r" ] && skip "missing /sys/.../ldlm_enqueue_min in the ost1" && return 0
1807     local ENQ_MIN=$(cat $ldlm_enqueue_min)
1808     local ENQ_MIN_R=$(do_facet ost1 "cat $ldlm_enqueue_min_r")
1809     echo $TIMEOUT >> $ldlm_enqueue_min
1810     do_facet ost1 "echo $TIMEOUT >> $ldlm_enqueue_min_r"
1811
1812     rm -rf $DIR/$tdir
1813     mkdir -p $DIR/$tdir
1814     lfs setstripe $DIR/$tdir --index=0 --count=1
1815 #define OBD_FAIL_LDLM_PAUSE_CANCEL       0x312
1816     sysctl -w lustre.fail_val=$(($TIMEOUT - 1))
1817     sysctl -w lustre.fail_loc=0x80000312
1818     cp /etc/profile $DIR/$tdir/${tfile}_1 || error "1st cp failed $?"
1819     sysctl -w lustre.fail_val=$((TIMEOUT * 5 / 4))
1820     sysctl -w lustre.fail_loc=0x80000312
1821     cp /etc/profile $DIR/$tdir/${tfile}_2 || error "2nd cp failed $?"
1822     sysctl -w lustre.fail_loc=0
1823
1824     echo $ENQ_MIN >> $ldlm_enqueue_min
1825     do_facet ost1 "echo $ENQ_MIN_R >> $ldlm_enqueue_min_r"
1826     rm -rf $DIR/$tdir
1827     return 0
1828 }
1829 run_test 68 "AT: verify slowing locks"
1830
1831 at_cleanup
1832 # end of AT tests includes above lines
1833
1834
1835 # start multi-client tests
1836 test_70a () {
1837         [ -z "$CLIENTS" ] && \
1838                 { skip "Need two or more clients." && return; }
1839         [ $CLIENTCOUNT -lt 2 ] && \
1840                 { skip "Need two or more clients, have $CLIENTCOUNT" && return; }
1841
1842         echo "mount clients $CLIENTS ..."
1843         zconf_mount_clients $CLIENTS $DIR
1844
1845         local clients=${CLIENTS//,/ }
1846         echo "Write/read files on $DIR ; clients $CLIENTS ... "
1847         for CLIENT in $clients; do
1848                 do_node $CLIENT dd bs=1M count=10 if=/dev/zero \
1849                         of=$DIR/${tfile}_${CLIENT} 2>/dev/null || \
1850                                 error "dd failed on $CLIENT"
1851         done
1852
1853         local prev_client=$(echo $clients | sed 's/^.* \(.\+\)$/\1/')
1854         for C in ${CLIENTS//,/ }; do
1855                 do_node $prev_client dd if=$DIR/${tfile}_${C} of=/dev/null 2>/dev/null || \
1856                         error "dd if=$DIR/${tfile}_${C} failed on $prev_client"
1857                 prev_client=$C
1858         done
1859         
1860         ls $DIR
1861 }
1862 run_test 70a "check multi client t-f"
1863
1864 check_dbench_load () {
1865         local clients=${1//,/ }
1866         local client=
1867
1868         for client in $clients; do
1869                 if ! do_node $client "ps ax | grep -v grep | awk '{ print $6 }' | grep -q rundbench"; then
1870                         error_noexit "rundbench load on $client failed!"
1871                         return 1
1872                 fi
1873         done
1874         return 0
1875 }
1876
1877 kill_dbench_load () {
1878         local clients=${1:-$(hostname)}
1879         do_nodes $clients "killall dbench"
1880 }
1881
1882 test_70b () {
1883         local clients=${CLIENTS:-$HOSTNAME}
1884
1885         zconf_mount_clients $clients $DIR
1886         
1887         local duration=300
1888         [ "$SLOW" = "no" ] && duration=60
1889         local cmd="rundbench 1 -t $duration"
1890         local PID=""
1891         do_nodesv $clients "set -x; MISSING_DBENCH_OK=$MISSING_DBENCH_OK \
1892                 PATH=:$PATH:$LUSTRE/utils:$LUSTRE/tests/:$DBENCH_LIB \
1893                 DBENCH_LIB=$DBENCH_LIB TESTSUITE=$TESTSUITE TESTNAME=$TESTNAME \
1894                 LCTL=$LCTL $cmd" &
1895         PID=$!
1896         log "Started rundbench load PID=$PID ..."
1897         ELAPSED=0
1898         NUM_FAILOVERS=0
1899         START_TS=$(date +%s)
1900         CURRENT_TS=$START_TS
1901         while [ $ELAPSED -lt $duration ]; do
1902                 if ! check_dbench_load $clients; then
1903                         kill_dbench_load $clients
1904                         break
1905                 fi
1906                 sleep 1
1907                 replay_barrier $SINGLEMDS
1908                 sleep 1 # give clients a time to do operations
1909                 # Increment the number of failovers
1910                 NUM_FAILOVERS=$((NUM_FAILOVERS+1))
1911                 log "$TESTNAME fail mds1 $NUM_FAILOVERS times"
1912                 fail $SINGLEMDS
1913                 CURRENT_TS=$(date +%s)
1914                 ELAPSED=$((CURRENT_TS - START_TS))
1915         done
1916         wait $PID || error "rundbench load on $CLIENTS failed!"
1917 }
1918 run_test 70b "mds recovery; $CLIENTCOUNT clients"
1919 # end multi-client tests
1920
1921 test_73a() {
1922     multiop_bg_pause $DIR/$tfile O_tSc || return 3
1923     pid=$!
1924     rm -f $DIR/$tfile
1925
1926     replay_barrier $SINGLEMDS
1927 #define OBD_FAIL_LDLM_ENQUEUE       0x302
1928     do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000302"
1929     fail $SINGLEMDS
1930     kill -USR1 $pid
1931     wait $pid || return 1
1932     [ -e $DIR/$tfile ] && return 2
1933     return 0
1934 }
1935 run_test 73a "open(O_CREAT), unlink, replay, reconnect before open replay , close"
1936
1937 test_73b() {
1938     multiop_bg_pause $DIR/$tfile O_tSc || return 3
1939     pid=$!
1940     rm -f $DIR/$tfile
1941
1942     replay_barrier $SINGLEMDS
1943 #define OBD_FAIL_LDLM_REPLY       0x30c
1944     do_facet $SINGLEMDS "lctl set_param fail_loc=0x8000030c"
1945     fail $SINGLEMDS
1946     kill -USR1 $pid
1947     wait $pid || return 1
1948     [ -e $DIR/$tfile ] && return 2
1949     return 0
1950 }
1951 run_test 73b "open(O_CREAT), unlink, replay, reconnect at open_replay reply, close"
1952
1953 test_73c() {
1954     multiop_bg_pause $DIR/$tfile O_tSc || return 3
1955     pid=$!
1956     rm -f $DIR/$tfile
1957
1958     replay_barrier $SINGLEMDS
1959 #define OBD_FAIL_TGT_LAST_REPLAY       0x710
1960     do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000710"
1961     fail $SINGLEMDS
1962     kill -USR1 $pid
1963     wait $pid || return 1
1964     [ -e $DIR/$tfile ] && return 2
1965     return 0
1966 }
1967 run_test 73c "open(O_CREAT), unlink, replay, reconnect at last_replay, close"
1968
1969 # bug 18554
1970 test_74() {
1971     local clients=${CLIENTS:-$HOSTNAME}
1972
1973     stop ost1
1974     zconf_umount_clients $clients $MOUNT
1975     facet_failover $SINGLEMDS
1976     zconf_mount_clients $clients $MOUNT
1977     mount_facet ost1
1978     touch $DIR/$tfile || return 1
1979     rm $DIR/$tfile || return 2
1980     clients_up || error "client evicted: $?"
1981     return 0
1982 }
1983 run_test 74 "Ensure applications don't fail waiting for OST recovery"
1984
1985 test_80a() {
1986     [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return 0
1987
1988     mkdir -p $DIR/$tdir
1989     replay_barrier mds2
1990     $CHECKSTAT -t dir $DIR/$tdir || error "$CHECKSTAT -t dir $DIR/$tdir failed"
1991     rmdir $DIR/$tdir || error "rmdir $DIR/$tdir failed"
1992     fail mds2
1993     stat $DIR/$tdir 2&>/dev/null && error "$DIR/$tdir still exist after recovery!"
1994     return 0
1995 }
1996 run_test 80a "CMD: unlink cross-node dir (fail mds with inode)"
1997
1998 test_80b() {
1999     [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return 0
2000
2001     mkdir -p $DIR/$tdir
2002     replay_barrier mds1
2003     $CHECKSTAT -t dir $DIR/$tdir || error "$CHECKSTAT -t dir $DIR/$tdir failed"
2004     rmdir $DIR/$tdir || error "rmdir $DIR/$tdir failed"
2005     fail mds1
2006     stat $DIR/$tdir 2&>/dev/null && error "$DIR/$tdir still exist after recovery!"
2007     return 0
2008 }
2009 run_test 80b "CMD: unlink cross-node dir (fail mds with name)"
2010
2011 test_81a() {
2012     [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return 0
2013
2014     mkdir -p $DIR/$tdir
2015     createmany -o $DIR/$tdir/f 3000 || error "createmany failed"
2016     sleep 10
2017     $CHECKSTAT -t dir $DIR/$tdir || error "$CHECKSTAT -t dir failed"
2018     $CHECKSTAT -t file $DIR/$tdir/f1002 || error "$CHECKSTAT -t file failed"
2019     replay_barrier mds1
2020     rm $DIR/$tdir/f1002 || error "rm $DIR/$tdir/f1002 failed"
2021     fail mds1
2022     stat $DIR/$tdir/f1002
2023 }
2024 run_test 81a "CMD: unlink cross-node file (fail mds with name)"
2025
2026 test_82a() {
2027     [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return 0
2028
2029     local dir=$DIR/d82a
2030     replay_barrier mds2
2031     mkdir $dir || error "mkdir $dir failed"
2032     log "FAILOVER mds2"
2033     fail mds2
2034     stat $DIR
2035     $CHECKSTAT -t dir $dir || error "$CHECKSTAT -t dir $dir failed"
2036 }
2037 run_test 82a "CMD: mkdir cross-node dir (fail mds with inode)"
2038
2039 test_82b() {
2040     [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return 0
2041
2042     local dir=$DIR/d82b
2043     replay_barrier mds1
2044     mkdir $dir || error "mkdir $dir failed"
2045     log "FAILOVER mds1"
2046     fail mds1
2047     stat $DIR
2048     $CHECKSTAT -t dir $dir || error "$CHECKSTAT -t dir $dir failed"
2049 }
2050 run_test 82b "CMD: mkdir cross-node dir (fail mds with name)"
2051
2052 test_83a() {
2053     mkdir -p $DIR/$tdir
2054     createmany -o $DIR/$tdir/$tfile- 10 || return 1
2055 #define OBD_FAIL_MDS_FAIL_LOV_LOG_ADD       0x140
2056     do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000140"
2057     unlinkmany $DIR/$tdir/$tfile- 10 || return 2
2058 }
2059 run_test 83a "fail log_add during unlink recovery"
2060
2061 test_83b() {
2062     mkdir -p $DIR/$tdir
2063     createmany -o $DIR/$tdir/$tfile- 10 || return 1
2064     replay_barrier $SINGLEMDS
2065     unlinkmany $DIR/$tdir/$tfile- 10 || return 2
2066 #define OBD_FAIL_MDS_FAIL_LOV_LOG_ADD       0x140
2067     do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000140"
2068     fail $SINGLEMDS
2069 }
2070 run_test 83b "fail log_add during unlink recovery"
2071
2072 test_84a() {
2073 #define OBD_FAIL_MDS_OPEN_WAIT_CREATE  0x144
2074     do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000144"
2075     createmany -o $DIR/$tfile- 1 &
2076     PID=$!
2077     mds_evict_client
2078     wait $PID
2079     client_up || client_up || true    # reconnect
2080 }
2081 run_test 84a "stale open during export disconnect"
2082
2083 test_86() {
2084         local clients=${CLIENTS:-$HOSTNAME}
2085
2086         zconf_umount_clients $clients $MOUNT
2087         do_facet $SINGLEMDS lctl set_param mdt.${FSNAME}-MDT*.exports.clear=0
2088         remount_facet $SINGLEMDS
2089         zconf_mount_clients $clients $MOUNT
2090 }
2091 run_test 86 "umount server after clear nid_stats should not hit LBUG"
2092
2093 test_87() {
2094     do_facet ost1 "lctl set_param -n obdfilter.${ost1_svc}.sync_journal 0"
2095
2096     replay_barrier ost1
2097     lfs setstripe -i 0 -c 1 $DIR/$tfile
2098     dd if=/dev/urandom of=$DIR/$tfile bs=1024k count=8 || error "Cannot write"
2099     cksum=`md5sum $DIR/$tfile | awk '{print $1}'`
2100     cancel_lru_locks osc
2101     fail ost1
2102     dd if=$DIR/$tfile of=/dev/null bs=1024k count=8 || error "Cannot read"
2103     cksum2=`md5sum $DIR/$tfile | awk '{print $1}'`
2104     if [ $cksum != $cksum2 ] ; then
2105         error "New checksum $cksum2 does not match original $cksum"
2106     fi
2107 }
2108 run_test 87 "write replay"
2109
2110 test_87b() {
2111     do_facet ost1 "lctl set_param -n obdfilter.${ost1_svc}.sync_journal 0"
2112
2113     replay_barrier ost1
2114     lfs setstripe -i 0 -c 1 $DIR/$tfile
2115     dd if=/dev/urandom of=$DIR/$tfile bs=1024k count=8 || error "Cannot write"
2116     sleep 1 # Give it a chance to flush dirty data
2117     echo TESTTEST | dd of=$DIR/$tfile bs=1 count=8 seek=64
2118     cksum=`md5sum $DIR/$tfile | awk '{print $1}'`
2119     cancel_lru_locks osc
2120     fail ost1
2121     dd if=$DIR/$tfile of=/dev/null bs=1024k count=8 || error "Cannot read"
2122     cksum2=`md5sum $DIR/$tfile | awk '{print $1}'`
2123     if [ $cksum != $cksum2 ] ; then
2124         error "New checksum $cksum2 does not match original $cksum"
2125     fi
2126 }
2127 run_test 87b "write replay with changed data (checksum resend)"
2128
2129 equals_msg `basename $0`: test complete, cleaning up
2130 check_and_cleanup_lustre
2131 [ -f "$TESTSUITELOG" ] && cat $TESTSUITELOG && grep -q FAIL $TESTSUITELOG && exit 1 || true